apiVersion: v1
kind: Template
labels:
  app: sonarqube
  template: sonarqube-secret
metadata:
  annotations:
    description: SonarQube - Secrets
      see https://gitlab.com/synacksynack/opsperator/docker-sonarqube
    iconClass: icon-openshift
    openshift.io/display-name: SonarQube
    tags: sonarqube
  name: sonarqube-secret
objects:
- apiVersion: v1
  kind: Secret
  metadata:
    annotations:
      jenkins.io/credentials-description : SonarQube Admin from Kubernetes
    labels:
      jenkins.io/credentials-type: usernamePassword
    name: sonar-admin
  stringData:
    password: "${ADMIN_PASSWORD}"
    username: admin
- apiVersion: v1
  kind: Secret
  metadata:
    annotations:
      jenkins.io/credentials-description : SonarQube Scanner from Kubernetes
    labels:
      jenkins.io/credentials-type: usernamePassword
    name: scanner
  stringData:
    password: "${SCANNER_PASSWORD}"
    username: "${SCANNER_USER}"
- apiVersion: v1
  kind: Secret
  metadata:
    annotations:
      template.openshift.io/expose-admin-password: '{.data[''database-admin-password'']}'
      template.openshift.io/expose-database_name: '{.data[''database-name'']}'
      template.openshift.io/expose-password: '{.data[''database-password'']}'
      template.openshift.io/expose-username: '{.data[''database-user'']}'
    name: sonarqube-postgres
  stringData:
    database-admin-password: ${POSTGRESQL_ADMIN_PASSWORD}
    database-name: ${POSTGRESQL_DATABASE}
    database-password: ${POSTGRESQL_PASSWORD}
    database-user: ${POSTGRESQL_USER}
parameters:
- description: SonarQube Password for the Admin account.
  displayName: SonarQube Administrator Password
  from: '[a-zA-Z0-9]{8}'
  generate: expression
  name: ADMIN_PASSWORD
- description: Username for PostgreSQL user that will be used for accessing the database.
  displayName: PostgreSQL Connection Username
  name: POSTGRESQL_USER
  value: sonar
- description: Password for the PostgreSQL connection user.
  displayName: PostgreSQL Connection Password
  from: '[a-zA-Z0-9]{16}'
  generate: expression
  name: POSTGRESQL_PASSWORD
- description: Password for the PostgreSQL Admin user.
  displayName: PostgreSQL Admin User Password
  from: '[a-zA-Z0-9]{16}'
  generate: expression
  name: POSTGRESQL_ADMIN_PASSWORD
- description: Name of the PostgreSQL database accessed.
  displayName: PostgreSQL Database Name
  name: POSTGRESQL_DATABASE
  value: sonar
- description: Username for Scanner user that will be used for accessing SonarQube.
  displayName: Sonar Scanner Connection Username
  name: SCANNER_USER
  value: scanner
- description: Password for the Sonar Scanner connection user.
  displayName: Sonar Scanner Connection Password
  from: '[a-zA-Z0-9]{16}'
  generate: expression
  name: SCANNER_PASSWORD
